package com.sun.jndi.dns;

import java.util.NoSuchElementException;
import javax.naming.NamingException;
import java.util.Hashtable;
import java.util.Enumeration;
import javax.naming.NamingEnumeration;

abstract class BaseNameClassPairEnumeration<T> implements NamingEnumeration<T>
{
    protected Enumeration<NameNode> nodes;
    protected DnsContext ctx;
    
    BaseNameClassPairEnumeration(DnsContext ctx, Hashtable<String, NameNode> hashtable) {
        this.ctx = ctx;
        this.nodes = ((hashtable != null) ? hashtable.elements() : null);
    }
    
    @Override
    public final void close() {
        this.nodes = null;
        this.ctx = null;
    }
    
    @Override
    public final boolean hasMore() {
        int n = this.nodes != null && this.nodes.hasMoreElements();
        if (n == 0) {
            this.close();
        }
        return n;
    }
    
    @Override
    public final boolean hasMoreElements() {
        return this.hasMore();
    }
    
    @Override
    public abstract T next() throws NamingException;
    
    @Override
    public final T nextElement() {
        try {
            return this.next();
        }
        catch (NamingException cause) {
            NoSuchElementException ex = new NoSuchElementException();
            ex.initCause(cause);
            throw ex;
        }
    }
}
